﻿using System;
using Wisej.Core;
using Wisej.Web;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Design;


namespace Wisej.PropertyGridSample
{
	public class AddressEditor : UITypeEditor
	{
		public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context)
		{
			return UITypeEditorEditStyle.Modal;
		}

		public override bool GetPaintValueSupported(ITypeDescriptorContext context)
		{
			return true;
		}

		public override object EditValue(ITypeDescriptorContext context, IServiceProvider provider, object value)
		{
			if (provider != null)
			{
				var service = (IWisejEditorService)provider.GetService(typeof(IWisejEditorService));
				if (service != null)
				{
					var address = (Address)value ?? new Address();
					using (var dialog = new AddressEditorDialog())
					{
						dialog.Value = address;
						if (dialog.ShowDialog() == DialogResult.OK)
							value = dialog.Value;
					}
				}
			}
			return value;
		}

		public override void PaintValue(PaintValueEventArgs e)
		{
			e.Graphics.DrawImage(marker, e.Bounds);
		}

		private static Image marker = Image.FromFile(Application.MapPath("Resources\\Marker.png"));
	}
}