﻿using System;
using Wisej.Core;
using Wisej.Web;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Design;
using System.Globalization;

namespace Wisej.PropertyGridSample
{
	public class AddressTypeConverter : TypeConverter
	{
		public override bool CanConvertFrom(ITypeDescriptorContext context, Type sourceType)
		{
			return base.CanConvertFrom(context, sourceType);
		}

		public override bool CanConvertTo(ITypeDescriptorContext context, Type destinationType)
		{
			return 
				destinationType == typeof(string)
				|| base.CanConvertTo(context, destinationType);
		}

		public override object ConvertTo(ITypeDescriptorContext context, CultureInfo culture, object value, Type destinationType)
		{
			if (destinationType == typeof(string))
			{
				var address = (Address)value;
				if (address == null || address.IsEmpty)
					return "(Empty)";
				else
					return $"{address.Address1}, {address.City} {address.State}, {address.ZipCode}";
			}

			return base.ConvertTo(context, culture, value, destinationType);
		}
	}
}