﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Drawing.Design;
using System.ComponentModel;

namespace Wisej.PropertyGridSample
{
	[DefaultProperty("Name")]
	public class DataItem
	{
		public DataItem()
		{
			this.Address = new Address();
		}

		[Description("The name of the DataItem.")]
		public string Name { get; set; }

		[TypeConverter(typeof(DateTypeConverter))]
		[Editor(typeof(DateEditor), typeof(UITypeEditor))]
		[Description("A DateTime value that can be edited using a MonthCalendar.")]
		public DateTime Calendar { get; set; }

		// Address editor and type converter are defined on the Address type.
		[Description("An Address object edited using a modal dialog.")]
		public Address Address { get; set; }
	}
}