﻿using System;
using Wisej.Core;
using Wisej.Web;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Design;
using System.Globalization;

namespace Wisej.PropertyGridSample
{
	public class DateTypeConverter : TypeConverter
	{
		public override bool CanConvertFrom(ITypeDescriptorContext context, Type sourceType)
		{
			return base.CanConvertFrom(context, sourceType);
		}

		public override bool CanConvertTo(ITypeDescriptorContext context, Type destinationType)
		{
			return 
				destinationType == typeof(string)
				|| base.CanConvertTo(context, destinationType);
		}

		public override object ConvertTo(ITypeDescriptorContext context, CultureInfo culture, object value, Type destinationType)
		{
			if (destinationType == typeof(string))
			{
				var date = (DateTime)value;
				if (date == DateTime.MinValue)
					return "(Select a date)";
				else
					return date.ToShortDateString();
			}

			return base.ConvertTo(context, culture, value, destinationType);
		}
	}
}